#ifndef __AABB_H__
#define __AABB_H__

#include "d3dx9.h"

//
// 3 dimensional Axis Aligned Bounding Box
//
class AABB3
{

    // boundary line
    float m_minX, m_maxX, m_minY, m_maxY, m_minZ, m_maxZ;

public :
    // constructor
    AABB3( float minX, float maxX, float minY, float maxY, float minZ, float maxZ );

    // reset
    void init( float x, float y, float z);
    void init( D3DXVECTOR3 v );

    // set
    void setAABB( float minX, float maxX, float minY, float maxY, float minZ, float maxZ );

    // object   ߰ϰ AABB Ѵ.
    void addPoint( float x, float y, float z );
    void addPoint( D3DXVECTOR3 v );

    // check if this box intersects with trg
    bool intersect( AABB3 arg );
    // check if this box intersects with pick line
    bool intersect( const D3DXVECTOR3 *vPickOrg, const D3DXVECTOR3 *vPickDir );
    // check if this box contains arg
    bool contains( AABB3 arg );

    // get the corners of the box
    void getVertices( D3DXVECTOR4 vCorner[8] );
    void getVertices( D3DXVECTOR3 vCorner[8] );

    // operator overloading
    bool operator!=( const AABB3 &arg );
    void operator =( const AABB3 &in );

    // get
    float getMinX()
    {
        return m_minX;
    }
    float getMaxX()
    {
        return m_maxX;
    }
    float getMinY()
    {
        return m_minY;
    }
    float getMaxY()
    {
        return m_maxY;
    }
    float getMinZ()
    {
        return m_minZ;
    }
    float getMaxZ()
    {
        return m_maxZ;
    }

    // set
    void setMinX( float v )
    {
        m_minX = v;
    }
    void setMaxX( float v )
    {
        m_maxX = v;
    }
    void setMinY( float v )
    {
        m_minY = v;
    }
    void setMaxY( float v )
    {
        m_maxY = v;
    }
    void setMinZ( float v )
    {
        m_minZ = v;
    }
    void setMaxZ( float v )
    {
        m_maxZ = v;
    }
};

#endif