#ifndef __MAPPATCH_H__
#define __MAPPATCH_H__

#include <d3dx9.h>
#include "MapVertex.h"
#include "AABB.h"

//
// map rendering  Ǵ class
//
class MapPatch
{
public :
    // constructor
    MapPatch( LPDIRECT3DDEVICE9 pd3dDevice, int left, int right, int bottom, int top, MapVertex *pMapVertices, int rowOffset );

    // destructor
    ~MapPatch()
    {
        release();
    }

    // ڿ ȯѴ.
    void release();

    // patch renderѴ.
    void render();

#ifdef EDITOR_BUILD
    // patch updateѴ.
    void update( int left, int right, int bottom, int top, MapVertex *pMapVertices, int rowOffset );
#endif

private :
    //  ׸µ Ǵ vertex 
    int m_numVertices;
    //  ׸µ Ǵ ﰢ 
    int m_primCount;

    // D3D device pointer
    LPDIRECT3DDEVICE9 m_pd3dDevice;
    //  ׸µ Ǵ vertex buffer
    LPDIRECT3DVERTEXBUFFER9 m_pVB;
    //  ׸µ index buffer
    LPDIRECT3DINDEXBUFFER9 m_pIB;
#ifdef EDITOR_BUILD
    //  
    int m_primCountLine;
    //  index buffer
    LPDIRECT3DINDEXBUFFER9 m_pGridIB;
    //  material property
    static D3DMATERIAL9 m_mtrlLine;
    //  ׸  ϴ world matrix
    static D3DXMATRIX m_matLine;
#endif

};

#endif