#include "TmpTri.h"
#include "udebug.h"

LPDIRECT3DVERTEXBUFFER9 TmpTri::m_vb = NULL;

void TmpTri::init( LPDIRECT3DDEVICE9 pd3dDevice, float x, float y, float z )
{
    if( FAILED(pd3dDevice->CreateVertexBuffer(
        3 * sizeof( MapVertex ), // length
        0, // usage
        D3DFVF_MAPVERTEX, // FVF
        D3DPOOL_DEFAULT, // Pool
        &m_vb, // ppVertexBuffer
        NULL // pShareHandle
        )))
    {
        UPRINT( "can't create vertex buffer at __FILE__(__LINE__)" );
        return;
    }

    MapVertex *vertices;
    if( FAILED(m_vb->Lock(
        0, // offsetToLock
        3 * sizeof( MapVertex ), // SizeToLock
        (void**)&vertices, // ppbData
        0 // Flags
        )))
    {
        UPRINT( "can't lock vertex buffer at __FILE__(__LINE__)" );
        return;
    }

    vertices[0].position = D3DXVECTOR3( x-0.5f, y, z-0.5f );
    vertices[0].normal = D3DXVECTOR3(0,1,0);
    vertices[1].position = D3DXVECTOR3( x, y, z+0.5f );
    vertices[1].normal = D3DXVECTOR3(0,1,0);
    vertices[2].position = D3DXVECTOR3( x+0.5f, y, z-0.5f );
    vertices[2].normal = D3DXVECTOR3(0,1,0);

    m_vb->Unlock();
}

void TmpTri::render( LPDIRECT3DDEVICE9 pd3dDevice )
{
    
    pd3dDevice->SetStreamSource( 0, m_vb, 0, sizeof( MapVertex ));
    pd3dDevice->SetFVF( D3DFVF_MAPVERTEX );
    pd3dDevice->DrawPrimitive(
        D3DPT_TRIANGLELIST, // PrimitiveType
        0,                  // StartVertex
        1                   // PrimitiveCount
        );
}

void TmpTri::release()
{
    if( m_vb )
    {
        m_vb->Release();
    }
}