#ifndef __UFRUSTUM_H__
#define __UFRUSTUM_H__

#include <d3dx9.h>
#include "AABB.h"

#define CLIP_LEFT   0  // left clipping plane
#define CLIP_RIGHT  1  // right clipping plane
#define CLIP_TOP    2  // top clipping plane
#define CLIP_BOTTOM 3  // bottom clipping plane
#define CLIP_NEAR   4  // near clipping plane
#define CLIP_FAR    5  // far clipping plane

enum CLIPTYPE
{
    FINSIDE,
    FOUTSIDE,
    FINTERSECT
};

class UFrustum
{
    D3DXPLANE m_planes[6];
public :
    // initialize frustum with view & projection compound matrix
    void init( D3DXMATRIX comboMatrix );

    // check if target is clipping by the
    CLIPTYPE check( AABB3 aabb );
};

#endif