#ifndef __UMAP_H__
#define __UMAP_H__

#include <d3dx9.h>
#include "UFrustum.h"
#include "QTree.h"

#ifdef EDITOR_BUILD
#include <deque>
#endif

//
//  ٷµ Ǵ class
//
class UMap
{

public :
    // constructor
    UMap();

    //  Ѵ.
    void create( LPDIRECT3DDEVICE9 pd3dDevice, int row, int col );

    //  оδ.
    void load( LPDIRECT3DDEVICE9 pd3dDevice, const char* filename);

    // ڿ ȯѴ.
    void release();

    //   ´.
    int getRow()
    {
        return m_row;
    }

    //   ´.
    int getCol()
    {
        return m_col;
    }

    // (x,z) ġ ̸ ´.
    bool getHeight( const float x, float *y, const float z );

    // 콺 Ŭ  ãƳ.
    bool findPickedPos( const D3DXVECTOR3 *vPickDir, const D3DXVECTOR3 *vPickOrg, D3DXVECTOR3 *vOut );

    //  renderingѴ.
    void render( UFrustum &frustum );

#ifdef EDITOR_BUILD
    //  Ѵ.
    void save( const char* filename );

    //  ̸ Ѵ.
    void changeHeight( float delta );

    // 콺 ̿ ִ vertex index returnѴ.
    // ٸ -1 returnѴ.
    int findCursorVertex( D3DXVECTOR3 *vPickDir, D3DXVECTOR3 *vPickOrg );

    // Ŀ  Ѵ.
    void makeCursorArea( int cursorIdx, int brushShape, int brushSize );

    // Ŀ  ׸.
    void drawCursor( LPDIRECT3DDEVICE9 pd3dDevice, int cursorIdx, int brushShape, int brushSize );

    //  Ѻ ִ ũ
    const static int MAP_MAX_SIZE = 256;
#endif

private :
    // ־ height map  ؼ map Ѵ.
    void create( LPDIRECT3DDEVICE9 pd3dDevice, int row, int col, float *pHeightMap );
    //  vertex Ѵ.
    void createVertices();
    // vertex normal Ѵ.
    void calcVN();
    // (x,y) vertex normal Ѵ.
    void updateVN( int x, int y );

    //  밡 ˷ִ flag
    bool m_bAvailable;

    //  
    int m_row;
    //  
    int m_col;
    // height map
    float *m_pHeightMap;
    // map vertex
    MapVertex *m_pMapVertices;

    // quad tree
    QTree m_qtree;

    //  texture
    LPDIRECT3DTEXTURE9 m_pMapTexture;

    //  material property
    D3DMATERIAL9 m_mtrlMap;

    // direct3d device pointer
    LPDIRECT3DDEVICE9 m_pd3dDevice;

#ifdef EDITOR_BUILD
    // cursor 
    std::deque<int> m_cursorArea;

    // cursor  world matrix
    static D3DXMATRIX m_matCursor;

    // Ŀ  index list
    static WORD pCursorIndex [];

    // cursor  material property
    D3DMATERIAL9 m_mtrlCursor;
#endif

    //   ϴ  Ǵ ĺ
    static char UMAP_FILE_ID [];
};

#endif