#ifndef __UTIMER_H__
#define __UTIMER_H__

#include <windows.h>

class _Timer
{
public :
    int m_FPS;

    virtual int getFPS();
};

class UTimer
{
public :
    _Timer *m_timer;

    // initialize
    void init();

    // release
    void release();

    // get FPS
    int getFPS();

};

//
// high-res timer
//
class HPTimer : public _Timer
{
public :
    LARGE_INTEGER m_startTime;
    LARGE_INTEGER m_ticksPerSecond;
    float m_lastTime;

    // constructor
    HPTimer();

    // get FPS
    int getFPS();
};

//
// normal timer
//
class NormalTimer : public _Timer
{
public :
    float m_startTime;
    float m_lastTime;

    // constructor
    NormalTimer();

    // get FPS
    int getFPS();
};

#endif