#ifndef __UDEBUG_H__

#include <d3dx9.h>
#include <string>
#include <deque>

using namespace std;

void initLog( LPDIRECT3DDEVICE9 pd3dDevice, RECT region, size_t maxMsgLines );
void releaseLog();
void UPRINT( char *format, ... );
void PRINTSCR( char *format, ... );

class Log
{
    // text sprite
    static LPD3DXSPRITE m_pTextSprite;

    // font
    static LPD3DXFONT m_pFont;

    // message list
    static deque<string> m_messages;

    // maximun number of message lines
    static size_t MAX_MSG_LINES;

    // a region where logging messages are printed
    static RECT m_region;

    // font size
    static int m_fontSize;

    static char *m_strFPS;

public :

    // initialize log modules
    static void init( LPDIRECT3DDEVICE9 pd3dDevice, RECT region, size_t maxMsgLines );

    // release resource
    static void release();

    // print message
    static void print( string msg );
    static void print( char *buffer );

    // render a logging message
    static void render( LPDIRECT3DDEVICE9 pd3dDevice );

    // set a string contains FPS informations
    static void setFPSStr( char *fpsStr)
    {
        m_strFPS = fpsStr;
    }
};

#endif