#ifndef __UTIL_H__
#define __UTIL_H__

#include <d3dx9.h>

void calcFaceNormal( D3DXVECTOR3 p[], D3DXVECTOR3 *out);

//
// calculate view direction and origin
//
// vDir     [out] pick direction
// vOrig    [out] pick origin
// x        [in]  x
// y        [in]  y
// matView  [in]  view matrix
// matProj  [in]  projection matrix
// viewport [in]  viewport
//
void calcViewDir( D3DXVECTOR3 *vPickRayDir, D3DXVECTOR3 *vPickRayOrig, int x, int y, const D3DXMATRIX *matView, const D3DXMATRIX *matProj, const D3DVIEWPORT9 *viewPort );

//
// Name: intersectTriangle()
// Desc: Given a ray origin (orig) and direction (dir), and three vertices of
//       of a triangle, this function returns TRUE and the interpolated texture
//       coordinates if the ray intersects the triangle
//
bool intersectTriangle( const D3DXVECTOR3& v0,
                        const D3DXVECTOR3& v1,
                        const D3DXVECTOR3& v2,
                        const D3DXVECTOR3& orig,
                        const D3DXVECTOR3& dir,
                        FLOAT* t, FLOAT* u, FLOAT* v );

#endif